--
--
-- build base table 2 for testing
connect ebr_schema/ebr_schema
drop table myemp cascade constraints;
create table myemp as select * from emp;
alter table myemp add primary key (empno);
--create public synonym myemp for ebr_schema.myemp; -- show public synonym issues
grant all on myemp to ebr_user;
connect ebr_user/ebr_user
select empno,ename,job,mgr,hiredate,sal,comm,deptno from ebr_schema.myemp;
--
pause
--
-- build first edition
connect ebr_schema/ebr_schema
create edition myedition1 as child of ora$base;	
grant use on edition myedition1 to ebr_schema,ebr_user;
-- 
connect ebr_user/ebr_user
select empno,ename,job,mgr,hiredate,sal,comm,deptno from ebr_schema.myemp; 
--
connect ebr_schema/ebr_schema
alter session set edition = myedition1;
select sys_context('Userenv','Current_Edition_name') CurrentEdition from dual;
--
create table mydept_table as select * from dept;
create editioning view mydept as select deptno,dname,loc from mydept_table;
grant all on mydept to ebr_user;
--create public synonym mydept for mydept;  -- don't do it
pause
--
alter table myemp rename to myemp_table;
create or replace editioning view myemp
as
select empno,ename,job,mgr,hiredate,sal,comm,deptno from myemp_table;
grant all on myemp_table to ebr_user;
--drop public synonym myemp;
--create public synonym myemp for ebr_schema.myemp;
--
-- 
connect ebr_user/ebr_user edition=myedition1
select * from mydept;
select empno,ename,job,mgr,hiredate,sal,comm,deptno from myemp; 
--
-- drop trigger(s) on myemp_table
-- create trigger(s) on myemp 
-- recompile views and pl/sql
--
--
pause
--
--
-- build second edition
connect ebr_schema/ebr_schema
create edition myedition2 as child of myedition1;
grant use on edition myedition2 to ebr_schema;
-- 
connect ebr_user/ebr_user
select empno,ename,job,mgr,hiredate,sal,comm,deptno from myemp_table; 
--
connect ebr_schema/ebr_schema
alter session set edition = myedition2;
select sys_context('Userenv','Current_Edition_name') CurrentEdition from dual;
--
-- testing
alter table mydept_table add (mgrempno number(4));
update mydept_table mt
  set mgrempno = (select empno from emp where job = 'MANAGER' and deptno = mt.deptno);
commit;
create or replace editioning view mydept as select deptno,dname,loc,mgrempno from mydept_table;
--
pause
--
-- Change Oracle objects
--
alter table myemp_table
  add (totpay number(9,2) as (nvl(sal,0)+nvl(comm,0)));
alter table myemp_table
  add (avgjobpay number(9,2));
create or replace editioning view myemp
as
select empno,ename,job,mgr,hiredate,sal,comm,totpay,avgjobpay,deptno from myemp_table;
--
create or replace function getavgjobpay(injob in myemp.job%type)
return number
as
  pragma autonomous_transaction;
  avgpay myemp.sal%type;
begin
  select avg(sal) into avgpay
      from myemp where job = injob;
  return round(avgpay,0);
end;
/
create or replace trigger myemp_table_avgpay
  before insert or update of sal on myemp_table
      for each row
      forward crossedition
      disable
  begin
    :new.avgjobpay := getavgjobpay(:new.job);
end;
/
alter trigger myemp_table_avgpay enable;
declare
  cptr number;
  retv number;
begin
  cptr := dbms_sql.open_cursor();
  dbms_sql.parse(c=>cptr,language_flag=>dbms_sql.native,
             statement=>'update myemp_table
                          set empno = empno',
             apply_crossedition_trigger=>'MYEMP_TABLE_AVGPAY');
  retv := dbms_sql.execute(cptr);
  dbms_sql.close_cursor(cptr);
  commit;
end;
/
--
pause
--
-- Test edition 2 
select * from myemp;
--
--
pause
--
-- Test edition 1 changes 
alter session set edition = myedition1;
-- edition1      
select empno,ename,sal,comm from myemp;
update myemp set sal = 1600, comm = 200 where empno = 7934;
commit;
-- edition 1
select * from myemp;
-- edition2
alter session set edition = myedition2;
select * from myemp;
