set long 4096
set echo on
set pagesize 100
set linesize 100
set serveroutput on
clear scr
pause Welcome to 11g for Developers
--
--
--
pause SQL*Plus
set exitcommit off 
--
pause
set exitcommit on
--
--
--
col timestamp  format a15 
col username   format a5 
col script     format a10 word_wrapped 
col identifier format a10 
col statement  format a15 word_wrapped
col message    format a15 word_wrapped 
truncate table sperrorlog;
set errorlogging on
@testscript
select * from sperrorlog order b user, timestamp;
--
set errorlogging on identifier 'rmoug'
@testscript
select * from sperrorlog where identifier='rmoug' order by user,timestamp;
--
drop table mylog;
create table mylog as select * from sperrorlog where rownum < 1;
set errorlogging on table mylog identifier 'rmoug'
@testscript
select * from mylog order by user,timestamp;
--
--
--
pause Virtual Columns
--
DROP TABLE EMPTESTV;
--
CREATE TABLE EMPTESTV AS SELECT * FROM EMP;
--
ALTER TABLE EMPTESTV ADD (income AS (NVL(SAL,0) + NVL(COMM,0)));
--
SELECT * FROM EMPTESTV;
--
DROP TABLE NEWEMP;
--
CREATE TABLE NEWEMP
       (EMPNO NUMBER(4) NOT NULL,
        ENAME VARCHAR2(10),
        JOB VARCHAR2(9),
        MGR NUMBER(4),
        HIREDATE DATE,
        SAL NUMBER(7, 2),
        COMM NUMBER(7, 2),
       	INCOME NUMBER(9,2) 
           GENERATED ALWAYS 
           AS (NVL("SAL",0)+NVL("COMM",0)) VIRTUAL,
        DEPTNO NUMBER(2));
INSERT INTO NEWEMP (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8369, 'SMITH',  'CLERK',     7902,
        TO_DATE('17-DEC-2000', 'DD-MON-YYYY'),  8000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8499, 'ALLEN',  'SALESMAN',  7698,
        TO_DATE('20-FEB-2001', 'DD-MON-YYYY'), 16000,  3000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8521, 'WARD',   'SALESMAN',  7698,
        TO_DATE('22-FEB-2001', 'DD-MON-YYYY'), 12500,  5000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8566, 'JONES',  'MANAGER',   7839,
        TO_DATE('2-APR-2001', 'DD-MON-YYYY'),  29750, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8654, 'MARTIN', 'SALESMAN',  7698,
        TO_DATE('28-SEP-2001', 'DD-MON-YYYY'), 12500, 14000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8698, 'BLAKE',  'MANAGER',   7839,
        TO_DATE('1-MAY-2001', 'DD-MON-YYYY'),  28500, NULL, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8782, 'CLARK',  'MANAGER',   7839,
        TO_DATE('9-JUN-2001', 'DD-MON-YYYY'),  24500, NULL, 10);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8788, 'SCOTT',  'ANALYST',   7566,
        TO_DATE('09-DEC-2002', 'DD-MON-YYYY'), 30000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8839, 'KING',   'PRESIDENT', NULL,
        TO_DATE('17-NOV-2001', 'DD-MON-YYYY'), 50000, NULL, 10);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8844, 'TURNER', 'SALESMAN',  7698,
        TO_DATE('8-SEP-2001', 'DD-MON-YYYY'),  15000,    0, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8876, 'ADAMS',  'CLERK',     7788,
        TO_DATE('12-JAN-2003', 'DD-MON-YYYY'), 11000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8900, 'JAMES',  'CLERK',     7698,
        TO_DATE('3-DEC-2001', 'DD-MON-YYYY'),   9500, NULL, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8902, 'FORD',   'ANALYST',   7566,
        TO_DATE('3-DEC-2001', 'DD-MON-YYYY'),  30000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8934, 'MILLER', 'CLERK',     7782,
        TO_DATE('23-JAN-2002', 'DD-MON-YYYY'), 13000, NULL, 10);
--
COMMIT;
select ename,sal,comm,income
  from newemp;
--
--
--
pause PIVOT
select * from
  (select job,deptno,income from newemp) query1
    pivot (avg(income)
    for deptno in (10 AS ACCOUNTING, 20 AS RESEARCH, 30 AS SALES))
    order by job;
--
pause PIVOT Multiple Columns
select * from (select ename,hiredate,job,deptno,income from newemp) qry1
  pivot (avg(income)
  for deptno
  in ( 10 AS ACCOUNTING,
       20 AS RESEARCH,
       30 AS SALES))
  order by job;  
--
pause PIVOT Multiple Aggregates
select * from
(select job,deptno,income from newemp) query1
   pivot (avg(income) avg ,max(income) max
   for deptno
   in ( 10 AS ACCTG,
        20 AS RSRCH))
   order by job;
--
pause PIVOT XML
select * from
   (select job,deptno,income from newemp) query1
     pivot xml (avg(income) incomes
     for deptno
     in ( ANY))
     order by job;
--
pause Simple UNPIVOT
select empno, colname || '=' || colval value
  from emp
  unpivot include nulls
   (colval
    for (colname)
    in (ENAME AS 'ENAME', JOB AS 'JOB')
   )
  order by empno,colname;
--
pause UNPIVOT
drop table pivot_emp_table;
create table pivot_emp_table as
select * from
  (select job,deptno,income from newemp) query1
    pivot (avg(income)
    for deptno in (10 AS ACCOUNTING, 20 AS RESEARCH, 30 AS SALES))
    order by job;
select * from pivot_emp_table;
select * from pivot_emp_table
  unpivot include nulls
    (avgpay for dept in (ACCOUNTING,RESEARCH,SALES))
order by job;
--
--
pause RESULT_CACHE
@resultcache1
--
@resultcache1a
--
pause PL/SQL RESULT_CACHE
@result_cache_off
@result_cache_on
@resultcacheplsql1
--
--
--
set serveroutput on
pause COMPOUND TRIGGER
DROP TRIGGER EMPCOMPOUND;
DROP TRIGGER EMPCOMPOUND2;
DROP TRIGGER EMP_FOLLOWS1;
DROP TRIGGER EMP_FOLLOWS2;
@empcompound
UPDATE emp SET SAL = 4000.01 WHERE ENAME = 'KING';
rollback;
--
pause MORE COMPOUND TRIGGER
@emp_follows1
@emp_follows2
@empcompound2
UPDATE emp SET SAL = 4000.01 WHERE ENAME = 'KING';
rollback;
--
pause SIMPLE_INTEGER
declare
--  mytestvar pls_integer := 2147483645;
  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause PLS_INTEGER
declare
  mytestvar pls_integer := 2147483645;
--  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause PL/SQL SEQUENCE
--
drop sequence ora11seq;
--
create sequence ora11seq
  start with 10 increment by 2;
--
declare
   myvalue pls_integer := 0;
begin
   dbms_output.put_line('Starting now...');
   for loopctr in 1..5 loop
       myvalue := ora11seq.nextval;
   end loop;
   dbms_output.put_line('Value of myvalue is ' || to_char(myvalue));
end;
/
pause PL/SQL CONTINUE
declare
   ctr pls_integer := 6;
begin
   dbms_output.put_line('Counting down to blastoff!');
   for loopctr in reverse 1 .. ctr loop
     if loopctr in (4,2) then
         continue;
     end if;
     dbms_output.put_line(to_char(loopctr));
   end loop;
   dbms_output.put_line('Blast Off!');
end;
/
--
--
--
pause REGEXP_COUNT
-- Counts occurrences 
--    of letter 'L'
--    starting in position 1
--    in a case-insenstive way 
select ename
      ,regexp_count(ename,'l',1,'i') EnameO 
   from emp;
--
pause PL/SQL FUNCTION CALL
CREATE OR REPLACE FUNCTION TEST_CALL
  ( inval1 IN NUMBER
  , inval2 IN NUMBER
  , inval3 IN NUMBER
  ) RETURN NUMBER AS
BEGIN
  RETURN inval1 + inval2 + inval3;
END TEST_CALL;
/
declare
  vara number := 23;
  varb number := 34;
  varc number := 45;
begin
  dbms_output.put_line('Pos  ' || test_call(vara,varb,varc));
  dbms_output.put_line('Name ' || test_call(inval3=>varc,inval1=>vara,inval2=>varb));
  dbms_output.put_line('Mix  ' || test_call(vara,inval3=>varc,inval2=>varb));
end;
/
--
--
--
pause LISTAGG and NTH_VALUE
--
-- setup using SQL*Plus command
col dept_employees format a59 word_wrapped
--
-- LISTAGG show aggregated names
select department_id,
       listagg(last_name, ', ')
       within group
       (order by last_name) dept_employees
       from hr.employees
       where department_id in (20,30)
       group by department_id
       order by department_id;
--
-- NTH_VALUE
select distinct department_id
    ,first_value(salary) ignore nulls  
      over (partition by department_id order by salary desc 
      ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) "1st"
    ,nth_value(salary,2) ignore nulls  
      over (partition by department_id  order by salary desc 
      ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) "2nd"
    ,nth_value(salary,3) ignore nulls  
      over (partition by department_id  order by salary desc 
      ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) "3rd"
    from hr.employees
    where department_id = 80
    order by department_id, "1st", "2nd", "3rd";
--
--
--
pause simple Recursive query
--
WITH CountDown(N) AS
( select 10 as N from dual
UNION ALL
select N - 1 AS N
from CountDown
where N > 0
)
SELECT *
FROM CountDown;
--
pause Recursive Query Example
-- setup using SQL*Plus command
col empname format a45
--
-- ANSI-standard code
with empConnect(last_name,employee_id,manager_id,lvl)
     as (select last_name, employee_id, manager_id, 1 lvl2 from hr.employees where manager_id is null
       	union all
         select emp.last_name, emp.employee_id, emp.manager_id, ec.lvl+1
         	from hr.employees emp, empConnect ec
        	where emp.manager_id = ec.employee_id)
     SEARCH DEPTH FIRST BY last_name SET order_by
select lvl,lpad(' ' ,3*lvl, ' ')||last_name empname
    from empConnect
    order by order_by;
--
-- the old non-ANSI way...
select level,lpad(' ',3*level)||last_name empname
  from hr.employees
  connect by prior employee_id = manager_id
  start with employee_id = 100
  order siblings by last_name;
--
pause ALL DONE...
